//*** This JavaScript library is copyright 2002 by Gavin Kistner and Refinery, Inc.
//*** Re-use and modification require permission
//*** http://www.refinery.com/
//*** mailto:gavin@refinery.com

var DynList_dragInfo,DynList_editInfo;
window.attachEvent('onload',MakeListsDynamic);

function MakeListsDynamic(){
	//DegugOut("MakeListsDynamic()",1);
	document.body.attachEvent('onmousemove',DynList_TrackDrag);
	document.body.attachEvent('onmouseup',DynList_StopDrag);
	var allOL = document.getElementsByTagName("OL");
	var allUL = document.getElementsByTagName("UL");
	var dynamicLists=[];
	var numLists=0;
	for (var i=0,len=allOL.length;i<len;i++){
		var list = allOL[i];
		if (list.className.indexOf("dynamic")!=-1) dynamicLists[numLists++] = list;
	}
	for (var i=0,len=allUL.length;i<len;i++){
		var list = allUL[i];
		if (list.className.indexOf("dynamic")!=-1) dynamicLists[numLists++] = list;
	}

	for (var i=0;i<numLists;i++){
		var list = dynamicLists[i];
		list.editable = (list.className.indexOf("editable")!=-1);
		list.reorderable = (list.className.indexOf("reorderable")!=-1);
		list.deleteable = (list.className.indexOf("deleteable")!=-1);
		list.growable = (list.className.indexOf("growable")!=-1);
		list.shuffle = (list.className.indexOf("shuffle")!=-1);

		var lis = list.childNodes;
		for (var j=0,len2=lis.length;j<len2;j++) DynList_TransformLI(lis[j],list);
		if (list.shuffle){
			var numChildren = lis.length;
			for (var j=0;j<numChildren;j++){
				var c1 = Math.round(Math.random()*(numChildren-1));
				var c2 = Math.round(Math.random()*(numChildren-1));
				if (c1!=c2) lis[c1].swapNode(lis[c2]);
			}
		}
		if (list.growable) AddBlankLine(list);
	}
}

function DynList_TransformLI(li,list){
	//DegugOut("DynList_TransformLI()",1);
	var inp = li.getElementsByTagName('input')[0];
	if (!inp || inp.tagName.toLowerCase()!="input") return;

	li.className = li.className.replace("newline","");

	//Kill trailing whitespace
	var lastChild = li.childNodes[li.childNodes.length-1];
	if (lastChild.nodeType==3){
		var whitespace = lastChild.nodeValue.match(/\s+/);
		if (whitespace.length==1 && whitespace[0]==lastChild.nodeValue) lastChild.removeNode();
	}
	if (list.reorderable || !list.editable){
		inp.readOnly=true;
		inp.tabIndex=-1;
	}
	if (!list.editable && !list.reorderable) inp.className+=(inp.className.length>0?" ":"")+"static";
	else inp.className=inp.className.replace(/ ?static/i,"").replace(/ ?editing/i,"");
	if (list.reorderable){
		inp.attachEvent('onmousedown',DynList_StartDrag);
		inp.attachEvent('onselectstart',DynList_StopSelect);
		if (list.editable){
			inp.attachEvent('onkeypress',DynList_SaveOnEnter);
			var btn = document.createElement("<button>");
			li.appendChild(btn);
			btn.innerText="edit";
			btn.onclick=DynList_Edit;
			btn.style.width="3.5em";
		}
	}
	if (list.deleteable){
		var btn = document.createElement("<button>");
		li.appendChild(btn);
		btn.innerText="delete";
		btn.onclick=DynList_Delete;
	}
}





function DynList_StartDrag(){
	var obj=event.srcElement;
	if (editTarget==obj) return;
	
	//DebugOut("DynList_StartDrag("+obj.value+")",1);
	DynList_StopEdit();
	var xywh = FindXY(obj);
	var dragOffset = {x:event.clientX-xywh.x, y:event.clientY-xywh.y};

	var dragObj = obj.cloneNode(true);
	document.body.appendChild(dragObj);
	dragObj.style.position='absolute';
	dragObj.style.pixelLeft = xywh.x;
	dragObj.style.pixelTop = xywh.y;
	dragObj.className="dragItem";
	obj.className="dragsource";

	DynList_dragInfo = { dragSrc:obj, dragObj:dragObj, dragOffset:dragOffset, lastOver:null, dropAbove:true };
}

function DynList_TrackDrag(){
	if (!DynList_dragInfo || !DynList_dragInfo.dragSrc) return;
	//DebugOut("DynList_TrackDrag()",2,true);

	DynList_dragInfo.dragObj.style.pixelTop = event.clientY-DynList_dragInfo.dragOffset.y+document.body.scrollTop;
	DynList_dragInfo.dragObj.style.zIndex=-1;
	var li = FindAncestor(document.elementFromPoint(event.x, event.y),"li");
	DynList_ShowDropOrder(li);
	DynList_dragInfo.dragObj.style.zIndex="";
}

function DynList_StopDrag(){
	if (!DynList_dragInfo || !DynList_dragInfo.dragSrc) return;
	//DebugOut("DynList_StopDrag()",1);
	with (DynList_dragInfo){
		if (lastOver){
			var srcLI = dragSrc.parentElement;
			var srcOL = srcLI.parentElement;
			if (dropAbove) srcOL.insertBefore(srcLI,lastOver);
			else if (lastOver.nextSibling) srcOL.insertBefore(srcLI,lastOver.nextSibling);
			else srcOL.appendChild(srcLI);
		}
		dragObj.removeNode();
		dragSrc.className="reorder";
		dragObj = null;
		dragSrc = null;
		DynList_HideDropOrder();
	}
}




var msg;
function DynList_ShowDropOrder(li){
	if (!li) return;
	var newOver,showAbove=true;
	var ping;
	var xywh = FindXYWH(li);
	if (event.clientY<(xywh.y+xywh.h/2)) newOver=li;
	else{
		newOver = li.nextSibling;
		if (newOver==null){
			newOver=li;
			showAbove=false;
		}
	}
	if (newOver.className.indexOf("newline")!=-1){
		newOver=newOver.previousSibling;
		showAbove=false;
	}
	if (newOver==DynList_dragInfo.lastOver && showAbove==DynList_dragInfo.dropAbove) return;
	DynList_HideDropOrder();
	if (newOver.parentElement !=DynList_dragInfo.dragSrc.parentElement.parentElement) return;
	DynList_dragInfo.lastOver=newOver;
	DynList_dragInfo.dropAbove=showAbove;

	newOver.className+=(newOver.className!=""?" ":"")+(!showAbove?"moveafter":"movebefore");
}

function DynList_HideDropOrder(){
	if (!DynList_dragInfo) return;
	with (DynList_dragInfo){
		if (lastOver) lastOver.className = lastOver.className.replace(/ ?moveafter/gi,"").replace(/ ?movebefore/gi,"");
		lastOver=null;
		dropAbove=null;
	}
}




function DynList_SaveOnEnter(){ if (event.keyCode==13) DynList_StopEdit(); }

var editTarget,editButton,oldValue;
function DynList_Edit(){
	DynList_StopEdit();

	editButton = event.srcElement;
	editButton.onclick=DynList_StopEdit;
	editButton.innerText="save";

	editTarget=editButton.parentElement.childNodes[0];
	editTarget.className="editing";
	editTarget.readOnly=false;
	editTarget.focus();
	
	oldValue=editTarget.value;
}

function DynList_StopEdit(){
	if (!editTarget) return;

	editButton.onclick=DynList_Edit;
	editButton.innerText="edit";

	editTarget.className="";
	editTarget.readOnly=true;
	editTarget.blur();
	if (editTarget.value!=oldValue) editTarget.edited=true;

	editTarget=null;
	editButton=null;
}

function DynList_StopSelect(){
	if (!editTarget) event.returnValue=false;
}


function DynList_Delete(){
	event.srcElement.parentElement.removeNode(true);
}


function AddBlankLine(list,focusNew){
	var li = document.createElement("<li>");
	var inp = document.createElement('<input type=text>');
	inp.name = (list.childNodes.length==0)?"listvalue":list.childNodes[0].childNodes[0].name;
	inp.onkeypress = DynList_AddNewOnEnter;
	inp.className = "editing";
	var btn = document.createElement("<button>");
	btn.innerText="add new";
	btn.onclick=DynList_AddNew;
	li.appendChild(inp);
	li.appendChild(btn);
	li.className="newline";
	list.appendChild(li);
	if (focusNew) inp.focus();
}

function DynList_AddNew(){
	var li = event.srcElement.parentElement;
	var btn = li.childNodes[1];
	btn.removeNode(true);
	var list = li.parentElement;
	DynList_TransformLI(li,list);
	AddBlankLine(list,true);
}
function DynList_AddNewOnEnter(){if (event.keyCode==13) DynList_AddNew();}

//debugLevel=1;