//*** This JavaScript library is copyright 2002 by Gavin Kistner and Refinery, Inc.
//*** Re-use or modification require permission
//*** http://www.refinery.com/
//*** mailto:gavin@refinery.com

function MakeASCII(str){
	//attempt to clean up a few common errors intelligently 
	var badChars=String.fromCharCode(8211,8212,8216,8217,8220,8221); //The characters which should be replaced
	var newChars="--''\"\""; //The equivalent characters to use in the replacement
	for (var i=0,len=badChars.length;i<len;i++) str = str.replace(new RegExp(badChars.charAt(i),"g"),newChars.charAt(i));
	return str.replace(/[^\t-~]/g,"");
}

function FindAncestor(me, elementType, attributeOrClass) {
	if (!me || (!elementType && !attributeOrClass)) return null;

	if ( (elementType==null || me.tagName.toLowerCase()==elementType.toLowerCase()) && (attributeOrClass==null || me.getAttribute(attributeOrClass) || me.className.indexOf(attributeOrClass)!=-1) ) return me;
	else return FindAncestor(me.parentElement, elementType, attributeOrClass);
}

function FindXY(obj){
	if (!obj) return { x:-document.body.scrollLeft,y:-document.body.scrollTop };
	else {
		var parentXY = FindXY(obj.offsetParent);
		return {x:obj.offsetLeft+parentXY.x, y:obj.offsetTop+parentXY.y};
	}
}

function FindXYWH(obj){
	if (!obj) return { x:0, y:0, w:0, h:0 };
	else {
		var objXY = FindXY(obj);
		return { x:objXY.x, y:objXY.y, w:obj.offsetWidth, h:obj.offsetHeight };
	}
}

var debugLevel,debugLine=0,lastDebugMsg,debugMsgCount=0;
function DebugOut(msg,verbosity,preventRepeats){
	if (this.debugLevel==null || debugLevel<verbosity) return;
	if (preventRepeats){
		if (msg==lastDebugMsg){
			debugMsgCount++;
			return;
		}
		lastDebugMsg = msg;
	}

	var out = document.getElementById('debugoutput');
	if (debugMsgCount>0){
		var dupsMessge = "previous output repeated "+debugMsgCount+" times...";
		if (out)	out.innerHTML="#"+(debugLine)+": "+dupsMessge+"<br>"+out.innerHTML;
		else alert(dupsMessge);
		debugMsgCount=0;
	}
	if (out)	out.innerHTML="#"+(debugLine++)+": "+msg.replace(/\n/g,"<br>").replace(/</g,"&lt;").replace(/>/g,"&gt;")+"<br>"+out.innerHTML;
	else alert(msg);

}

